/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 11 "trafgen_parser.y" /* yacc.c:339  */


#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <stdint.h>
#include <errno.h>
#include <stdbool.h>
#include <libgen.h>
#include <net/if_arp.h>
#include <netinet/in.h>
#include <linux/if_ether.h>

#include "xmalloc.h"
#include "trafgen_parser.tab.h"
#include "trafgen_conf.h"
#include "trafgen_proto.h"
#include "trafgen_l2.h"
#include "trafgen_l3.h"
#include "trafgen_l4.h"
#include "built_in.h"
#include "die.h"
#include "str.h"
#include "csum.h"
#include "cpp.h"

#define YYERROR_VERBOSE		0
#define YYDEBUG			0
#define YYENABLE_NLS		1
#define YYLTYPE_IS_TRIVIAL	1
#define ENABLE_NLS		1

extern FILE *yyin;
extern int yylex(void);
extern void yy_scan_string(char *);
extern void yylex_destroy();
extern void yyerror(const char *);
extern int yylineno;
extern char *yytext;

extern struct packet *packets;
extern size_t plen;

#define packet_last		(plen - 1)

#define payload_last		(packets[packet_last].len - 1)

extern struct packet_dyn *packet_dyn;
extern size_t dlen;

#define packetd_last		(dlen - 1)

#define packetdc_last		(packet_dyn[packetd_last].clen - 1)
#define packetdr_last		(packet_dyn[packetd_last].rlen - 1)
#define packetds_last		(packet_dyn[packetd_last].slen - 1)

static int our_cpu, min_cpu = -1, max_cpu = -1;

static struct proto_hdr *hdr;

static inline int test_ignore(void)
{
	if (min_cpu < 0 && max_cpu < 0)
		return 0;
	else if (max_cpu >= our_cpu && min_cpu <= our_cpu)
		return 0;
	else
		return 1;
}

static inline void __init_new_packet_slot(struct packet *slot)
{
	slot->payload = NULL;
	slot->len = 0;
}

static inline void __init_new_counter_slot(struct packet_dyn *slot)
{
	slot->cnt = NULL;
	slot->clen = 0;
}

static inline void __init_new_randomizer_slot(struct packet_dyn *slot)
{
	slot->rnd = NULL;
	slot->rlen = 0;
}

static inline void __init_new_csum_slot(struct packet_dyn *slot)
{
	slot->csum = NULL;
	slot->slen = 0;
}

static inline void __setup_new_counter(struct counter *c, uint8_t start,
				       uint8_t stop, uint8_t stepping,
				       int type)
{
	c->min = start;
	c->max = stop;
	c->inc = stepping;
	c->val = (type == TYPE_INC) ? start : stop;
	c->off = payload_last;
	c->type = type;
}

static inline void __setup_new_randomizer(struct randomizer *r)
{
	r->off = payload_last;
}

static inline void __setup_new_csum16(struct csum16 *s, off_t from, off_t to,
				      enum csum which)
{
	s->off = payload_last - 1;
	s->from = from;
	s->to = to;
	s->which = which;
}

static void realloc_packet(void)
{
	if (test_ignore())
		return;

	plen++;
	packets = xrealloc(packets, plen * sizeof(*packets));

	__init_new_packet_slot(&packets[packet_last]);

	dlen++;
	packet_dyn = xrealloc(packet_dyn, dlen * sizeof(*packet_dyn));

	__init_new_counter_slot(&packet_dyn[packetd_last]);
	__init_new_randomizer_slot(&packet_dyn[packetd_last]);
	__init_new_csum_slot(&packet_dyn[packetd_last]);
}

struct packet *current_packet(void)
{
	return &packets[packet_last];
}

static void set_byte(uint8_t val)
{
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	pkt->payload[payload_last] = val;
}

static void set_multi_byte(uint8_t *s, size_t len)
{
	size_t i;

	for (i = 0; i < len; ++i)
		set_byte(s[i]);
}

void set_fill(uint8_t val, size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = val;
}

static void __set_csum16_dynamic(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	pkt->len += 2;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->slen++;
	pktd->csum = xrealloc(pktd->csum, pktd->slen * sizeof(struct csum16));

	__setup_new_csum16(&pktd->csum[packetds_last], from, to, which);
}

static void __set_csum16_static(size_t from, size_t to, enum csum which __maybe_unused)
{
	struct packet *pkt = &packets[packet_last];
	uint16_t sum;
	uint8_t *psum;

	sum = htons(calc_csum(pkt->payload + from, to - from));
	psum = (uint8_t *) &sum;

	set_byte(psum[0]);
	set_byte(psum[1]);
}

static inline bool is_dynamic_csum(enum csum which)
{
	switch (which) {
	case CSUM_UDP:
	case CSUM_TCP:
	case CSUM_UDP6:
	case CSUM_TCP6:
		return true;
	default:
		return false;
	}
}

static void set_csum16(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	if (to < from) {
		size_t tmp = to;

		to = from;
		from = tmp;
	}

	bug_on(!(from < to));

	if (packet_dyn_has_elems(pktd) || to >= pkt->len || is_dynamic_csum(which))
		__set_csum16_dynamic(from, to, which);
	else
		__set_csum16_static(from, to, which);
}

static void set_rnd(size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = (uint8_t) rand();
}

static void set_sequential_inc(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		off_t off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start += stepping;
	}
}

static void set_sequential_dec(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		int off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start -= stepping;
	}
}

static void set_dynamic_rnd(void)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->rlen++;
	pktd->rnd = xrealloc(pktd->rnd, pktd->rlen * sizeof(struct randomizer));

	__setup_new_randomizer(&pktd->rnd[packetdr_last]);
}

static void set_dynamic_incdec(uint8_t start, uint8_t stop, uint8_t stepping,
			       int type)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->clen++;
	pktd->cnt = xrealloc(pktd->cnt, pktd->clen * sizeof(struct counter));

	__setup_new_counter(&pktd->cnt[packetdc_last], start, stop, stepping, type);
}

static void proto_add(enum proto_id pid)
{
	hdr = proto_header_init(pid);
}


#line 398 "trafgen/trafgen_parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "trafgen_parser.tab.h".  */
#ifndef YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
# define YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    K_COMMENT = 258,
    K_FILL = 259,
    K_RND = 260,
    K_SEQINC = 261,
    K_SEQDEC = 262,
    K_DRND = 263,
    K_DINC = 264,
    K_DDEC = 265,
    K_WHITE = 266,
    K_CPU = 267,
    K_CSUMIP = 268,
    K_CSUMUDP = 269,
    K_CSUMTCP = 270,
    K_CSUMUDP6 = 271,
    K_CSUMTCP6 = 272,
    K_CONST8 = 273,
    K_CONST16 = 274,
    K_CONST32 = 275,
    K_CONST64 = 276,
    K_DADDR = 277,
    K_SADDR = 278,
    K_ETYPE = 279,
    K_OPER = 280,
    K_SHA = 281,
    K_SPA = 282,
    K_THA = 283,
    K_TPA = 284,
    K_REQUEST = 285,
    K_REPLY = 286,
    K_PTYPE = 287,
    K_HTYPE = 288,
    K_PROT = 289,
    K_TTL = 290,
    K_DSCP = 291,
    K_ECN = 292,
    K_TOS = 293,
    K_LEN = 294,
    K_ID = 295,
    K_FLAGS = 296,
    K_FRAG = 297,
    K_IHL = 298,
    K_VER = 299,
    K_CSUM = 300,
    K_DF = 301,
    K_MF = 302,
    K_SPORT = 303,
    K_DPORT = 304,
    K_SEQ = 305,
    K_ACK_SEQ = 306,
    K_DOFF = 307,
    K_CWR = 308,
    K_ECE = 309,
    K_URG = 310,
    K_ACK = 311,
    K_PSH = 312,
    K_RST = 313,
    K_SYN = 314,
    K_FIN = 315,
    K_WINDOW = 316,
    K_URG_PTR = 317,
    K_TPID = 318,
    K_TCI = 319,
    K_PCP = 320,
    K_DEI = 321,
    K_1Q = 322,
    K_1AD = 323,
    K_LABEL = 324,
    K_TC = 325,
    K_LAST = 326,
    K_EXP = 327,
    K_ETH = 328,
    K_VLAN = 329,
    K_MPLS = 330,
    K_ARP = 331,
    K_IP4 = 332,
    K_UDP = 333,
    K_TCP = 334,
    number = 335,
    string = 336,
    mac = 337,
    ip4_addr = 338
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 343 "trafgen_parser.y" /* yacc.c:355  */

	struct in_addr ip4_addr;
	long long int number;
	uint8_t bytes[256];
	char *str;

#line 529 "trafgen/trafgen_parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 546 "trafgen/trafgen_parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   501

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  103
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  54
/* YYNRULES -- Number of rules.  */
#define YYNRULES  179
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  496

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   338

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    92,    93,     2,
      83,    84,    90,    89,    80,    88,     2,    91,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    87,     2,
      95,   102,    96,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    85,     2,    86,    97,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    81,    94,    82,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    98,    99,   100,   101
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   381,   381,   382,   383,   384,   388,   392,   393,   397,
     398,   402,   403,   404,   408,   409,   412,   419,   434,   444,
     445,   449,   450,   454,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   474,   476,   478,
     480,   482,   484,   486,   488,   490,   492,   494,   496,   498,
     503,   508,   510,   515,   520,   528,   533,   535,   537,   539,
     541,   546,   548,   553,   555,   560,   562,   571,   573,   578,
     580,   585,   586,   587,   588,   589,   590,   591,   595,   599,
     603,   604,   605,   609,   610,   614,   616,   618,   623,   627,
     631,   632,   633,   637,   638,   642,   644,   646,   648,   650,
     652,   654,   659,   663,   667,   668,   669,   673,   674,   678,
     680,   682,   684,   689,   693,   694,   695,   699,   701,   703,
     705,   707,   709,   711,   713,   715,   717,   719,   723,   727,
     731,   732,   733,   737,   739,   741,   743,   745,   747,   749,
     751,   753,   755,   757,   759,   761,   762,   763,   765,   770,
     774,   778,   779,   780,   784,   786,   788,   790,   795,   799,
     803,   804,   805,   809,   811,   813,   815,   817,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   829,   831,   836
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_COMMENT", "K_FILL", "K_RND",
  "K_SEQINC", "K_SEQDEC", "K_DRND", "K_DINC", "K_DDEC", "K_WHITE", "K_CPU",
  "K_CSUMIP", "K_CSUMUDP", "K_CSUMTCP", "K_CSUMUDP6", "K_CSUMTCP6",
  "K_CONST8", "K_CONST16", "K_CONST32", "K_CONST64", "K_DADDR", "K_SADDR",
  "K_ETYPE", "K_OPER", "K_SHA", "K_SPA", "K_THA", "K_TPA", "K_REQUEST",
  "K_REPLY", "K_PTYPE", "K_HTYPE", "K_PROT", "K_TTL", "K_DSCP", "K_ECN",
  "K_TOS", "K_LEN", "K_ID", "K_FLAGS", "K_FRAG", "K_IHL", "K_VER",
  "K_CSUM", "K_DF", "K_MF", "K_SPORT", "K_DPORT", "K_SEQ", "K_ACK_SEQ",
  "K_DOFF", "K_CWR", "K_ECE", "K_URG", "K_ACK", "K_PSH", "K_RST", "K_SYN",
  "K_FIN", "K_WINDOW", "K_URG_PTR", "K_TPID", "K_TCI", "K_PCP", "K_DEI",
  "K_1Q", "K_1AD", "K_LABEL", "K_TC", "K_LAST", "K_EXP", "K_ETH", "K_VLAN",
  "K_MPLS", "K_ARP", "K_IP4", "K_UDP", "K_TCP", "','", "'{'", "'}'", "'('",
  "')'", "'['", "']'", "':'", "'-'", "'+'", "'*'", "'/'", "'%'", "'&'",
  "'|'", "'<'", "'>'", "'^'", "number", "string", "mac", "ip4_addr", "'='",
  "$accept", "packets", "inline_comment", "cpu_delim", "delimiter_nowhite",
  "noenforce_white", "skip_white", "packet", "payload", "delimiter",
  "elem_delimiter", "elem", "expression", "fill", "const", "rnd", "csum",
  "seqinc", "seqdec", "drnd", "dinc", "ddec", "proto", "eth_proto", "eth",
  "eth_param_list", "eth_type", "eth_field", "vlan_proto", "vlan",
  "vlan_param_list", "vlan_type", "vlan_field", "mpls_proto", "mpls",
  "mpls_param_list", "mpls_tc", "mpls_field", "arp_proto",
  "arp_param_list", "arp_field", "arp", "ip4_proto", "ip4_param_list",
  "ip4_field", "ip4", "udp_proto", "udp_param_list", "udp_field", "udp",
  "tcp_proto", "tcp_param_list", "tcp_field", "tcp", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      44,   123,   125,    40,    41,    91,    93,    58,    45,    43,
      42,    47,    37,    38,   124,    60,    62,    94,   335,   336,
     337,   338,    61
};
# endif

#define YYPACT_NINF -366

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-366)))

#define YYTABLE_NINF -14

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -366,     8,  -366,  -366,  -366,   -81,    -8,  -366,  -366,   -91,
    -366,    -2,  -366,    92,    59,  -366,   -71,   -65,   -56,   -46,
     -42,   -18,     7,     9,    10,    31,    41,    49,    70,    72,
      73,    74,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,
    -366,  -366,    11,  -366,  -366,  -366,  -366,  -366,  -366,  -366,
    -366,  -366,  -366,  -366,  -366,    76,  -366,    77,  -366,    78,
    -366,    79,  -366,    80,  -366,    81,  -366,    89,    64,  -366,
    -366,    38,    75,    85,    86,    87,   -70,    88,    90,    91,
      95,    97,    98,    99,   -58,   -58,   -58,   -58,    93,   105,
     110,    92,  -366,    94,   114,    68,   312,   257,    96,   260,
      -8,   118,    53,   124,    53,    53,  -366,   129,    53,    53,
      53,    53,    53,    53,    53,   -58,   -58,  -366,   239,   263,
     277,   291,  -366,  -366,   163,   163,  -366,  -366,   137,   163,
      53,  -366,   163,  -366,   163,   163,   163,  -366,  -366,   152,
     163,    53,   163,   163,  -366,   163,  -366,   157,   163,    53,
     163,   163,   163,   163,   163,  -366,  -366,   163,   163,   166,
      53,   163,   163,   163,   163,   163,   163,   163,   163,   163,
     163,   163,   163,   163,   163,  -366,  -366,   167,    53,   163,
     163,   163,   163,   168,    53,   163,   163,   163,   163,   163,
     163,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,   163,
     163,   169,    53,   113,   111,  -366,  -366,   165,  -366,   170,
     171,  -366,   172,   173,   178,   179,   180,   183,   184,   306,
    -366,  -366,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   188,
     189,   -58,  -366,  -366,  -366,  -366,   162,   164,  -366,   182,
      94,   185,   186,   204,   205,  -366,   222,   114,   223,   224,
     244,  -366,   246,    68,   261,   262,   274,   275,   276,   287,
     289,  -366,   312,   302,   303,   304,   305,   307,   308,   309,
     310,   311,   313,   314,   315,   316,   317,  -366,   257,   318,
     319,   320,   321,  -366,    96,   322,   323,   324,   327,   328,
     329,   330,   331,  -366,   260,    -8,    -8,   202,    -7,    45,
      46,    47,   278,   350,   351,   352,   353,  -366,  -366,  -366,
    -366,  -366,  -366,  -366,  -366,   -58,   -58,  -366,   163,   163,
     163,  -366,   163,   163,   163,   163,   163,  -366,   163,   163,
     163,   163,  -366,   163,   163,   163,   163,   163,   163,   163,
    -366,   163,   163,   163,   163,   163,   163,   163,   163,   163,
     163,   163,   163,   163,   163,  -366,   163,   163,   163,   163,
    -366,   163,   163,   163,   163,   163,   163,   163,   163,  -366,
      92,   333,  -366,  -366,   340,  -366,   341,  -366,   342,  -366,
     343,  -366,  -366,  -366,  -366,  -366,  -366,  -366,   344,   345,
     348,   349,   355,   356,   357,   358,   359,   360,   361,   362,
      44,   363,   347,   364,   365,   367,   369,   368,   370,   372,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   390,   391,   392,   393,   394,
     395,   396,   397,    11,    -8,   366,   412,   413,   414,  -366,
    -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,
    -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,
    -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,
    -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,  -366,
    -366,  -366,  -366,  -366,  -366,  -366,   326,    92,  -366,  -366,
    -366,  -366,  -366,    11,   417,  -366
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     6,     5,     0,    11,     4,     3,     0,
      12,     9,    13,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    79,    89,   103,   128,   149,   158,   179,    24,
      25,    36,    11,    19,    26,    34,    27,    33,    29,    30,
      28,    31,    32,    35,    71,     0,    72,     0,    73,     0,
      74,     0,    75,     0,    76,     0,    77,     0,     0,     7,
       8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,    21,
       0,     0,    20,    80,    90,   104,   114,   130,   151,   160,
      11,     0,     0,     0,     0,     0,    65,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,     0,
       0,     0,    16,    23,    14,    14,    83,    84,     0,    14,
      81,    94,    14,    93,    14,    14,    14,    96,    97,     0,
      14,    91,    14,    14,   107,    14,   108,     0,    14,   105,
      14,    14,    14,    14,    14,   120,   121,    14,    14,     0,
     115,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,   145,   146,     0,   131,    14,
      14,    14,    14,     0,   152,    14,    14,    14,    14,    14,
      14,   168,   169,   170,   171,   172,   173,   174,   175,    14,
      14,     0,   161,     0,     0,    22,    21,     0,    55,     0,
       0,    66,     0,     0,     0,     0,     0,     0,     0,     0,
      48,    51,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    52,    53,    54,    15,     0,     0,    78,     0,
      80,     0,     0,     0,     0,    88,     0,    90,     0,     0,
       0,   102,     0,   104,     0,     0,     0,     0,     0,     0,
       0,   113,   114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   129,   130,     0,
       0,     0,     0,   150,   151,     0,     0,     0,     0,     0,
       0,     0,     0,   159,   160,    11,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,    39,    38,
      40,    41,    42,    43,    44,     0,     0,    45,    14,    14,
      14,    82,    14,    14,    14,    14,    14,    92,    14,    14,
      14,    14,   106,    14,    14,    14,    14,    14,    14,    14,
     116,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,   132,    14,    14,    14,    14,
     153,    14,    14,    14,    14,    14,    14,    14,    14,   162,
       0,     0,    50,    61,     0,    63,     0,    67,     0,    69,
       0,    56,    58,    57,    60,    59,    46,    47,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    11,    11,     0,     0,     0,     0,    85,
      86,    87,   101,    98,    99,   100,    95,   112,   109,   111,
     110,   117,   118,   119,   124,   126,   125,   127,   123,   122,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     147,   134,   133,   148,   156,   157,   154,   155,   177,   163,
     164,   165,   166,   167,   176,   178,     0,     0,    62,    64,
      68,    70,    18,    11,     0,    17
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -366,  -366,   266,  -366,    -6,   -41,  -119,  -366,  -365,   -26,
    -366,   371,    34,  -366,  -366,  -366,  -366,  -366,  -366,  -366,
    -366,  -366,  -366,  -366,  -366,   203,  -366,  -366,  -366,  -366,
     195,  -366,  -366,  -366,  -366,   196,  -366,  -366,  -366,   199,
    -366,  -366,  -366,   190,  -366,  -366,  -366,   216,  -366,  -366,
    -366,   207,  -366,  -366
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    41,    71,   206,    13,   236,     8,    42,    91,
      92,    43,   118,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,   128,   129,   130,    56,    57,
     139,   140,   141,    58,    59,   147,   148,   149,    60,   159,
     160,    61,    62,   177,   178,    63,    64,   183,   184,    65,
      66,   201,   202,    67
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      12,    90,     9,    10,   205,   433,   237,    14,     2,    15,
     239,     3,    72,   241,   106,   242,   243,   244,    73,     4,
       5,   246,    88,   248,   249,   115,   250,    74,   107,   252,
     116,   254,   255,   256,   257,   258,    89,    75,   259,   260,
     117,    76,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   205,   205,   205,   203,
     279,   280,   281,   282,   205,    77,   285,   286,   287,   288,
     289,   290,    11,    11,   451,   452,   207,   373,   209,   210,
     291,   292,   212,   213,   214,   215,   216,   217,   218,     6,
      78,    11,    79,    80,    12,     3,    16,    17,    18,    19,
      20,    21,    22,   142,   240,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    81,   247,   124,   125,   126,   119,
     120,   121,   493,   253,    82,    11,    11,    11,   127,   375,
     377,   379,    83,    11,   262,   179,   101,   143,   144,   145,
     146,   180,   453,    68,   181,   182,    69,    70,   131,   219,
     220,   100,   278,    84,   132,    85,    86,    87,   284,    93,
      94,    95,    96,    97,    98,    32,    33,    34,    35,    36,
      37,    38,    99,   102,   235,   -12,   294,   133,   134,   135,
     136,   137,   138,   103,   104,   105,   108,   -13,   109,   110,
      39,    40,   122,   111,   295,   112,   113,   114,   296,   388,
     389,   390,   204,   391,   392,   393,   394,   395,   208,   396,
     397,   398,   399,   211,   400,   401,   402,   403,   404,   405,
     406,   238,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   245,   421,   422,   423,
     424,   251,   425,   426,   427,   428,   429,   430,   431,   432,
     261,   277,   283,   293,   370,   371,   308,   309,   310,   311,
     312,   313,   314,   297,   318,   317,   319,     7,   298,   299,
     300,   301,   374,   376,   378,   380,   302,   303,   304,   161,
     162,   305,   306,   315,   320,   316,   372,   322,   323,    12,
      12,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   185,   324,   325,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   221,   326,   328,   329,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   330,   232,   331,   386,
     387,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   233,   381,   333,   334,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   234,   335,   336,   337,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   338,
     307,   339,   486,   487,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   341,   342,   343,   344,   492,   345,
     346,   347,   348,   349,   434,   350,   351,   352,   353,   354,
     356,   357,   358,   359,   361,   362,   363,    89,    12,   364,
     365,   366,   367,   368,   382,   383,   384,   385,   435,   436,
     437,   438,   327,   321,   439,   440,   441,   442,   455,   332,
     488,     0,   494,   443,   444,   445,   446,   447,   448,   449,
     450,   340,   123,   454,   456,   458,   457,   459,   355,   460,
     462,   461,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    89,   478,   479,
     480,   481,   482,   483,   484,   485,   489,   490,   491,   495,
     360,   369
};

static const yytype_int16 yycheck[] =
{
       6,    42,    83,    11,    11,   370,   125,    98,     0,    11,
     129,     3,    83,   132,    84,   134,   135,   136,    83,    11,
      12,   140,    11,   142,   143,    83,   145,    83,    98,   148,
      88,   150,   151,   152,   153,   154,    42,    83,   157,   158,
      98,    83,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,    11,    11,    11,   100,
     179,   180,   181,   182,    11,    83,   185,   186,   187,   188,
     189,   190,    80,    80,    30,    31,   102,    84,   104,   105,
     199,   200,   108,   109,   110,   111,   112,   113,   114,    81,
      83,    80,    83,    83,   100,     3,     4,     5,     6,     7,
       8,     9,    10,    35,   130,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    83,   141,    22,    23,    24,    85,
      86,    87,   487,   149,    83,    80,    80,    80,    34,    84,
      84,    84,    83,    80,   160,    39,    98,    69,    70,    71,
      72,    45,    98,    84,    48,    49,    87,    88,    34,   115,
     116,    87,   178,    83,    40,    83,    83,    83,   184,    83,
      83,    83,    83,    83,    83,    73,    74,    75,    76,    77,
      78,    79,    83,    98,    11,    82,   202,    63,    64,    65,
      66,    67,    68,    98,    98,    98,    98,    82,    98,    98,
      98,    99,    82,    98,    81,    98,    98,    98,    87,   318,
     319,   320,    84,   322,   323,   324,   325,   326,    84,   328,
     329,   330,   331,    84,   333,   334,   335,   336,   337,   338,
     339,    84,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,    84,   356,   357,   358,
     359,    84,   361,   362,   363,   364,   365,   366,   367,   368,
      84,    84,    84,    84,   295,   296,   222,   223,   224,   225,
     226,   227,   228,    98,   102,   231,   102,     1,    98,    98,
      98,    98,   298,   299,   300,   301,    98,    98,    98,    22,
      23,    98,    98,    95,   102,    96,    84,   102,   102,   295,
     296,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    45,   102,   102,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    84,   102,   102,   102,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    25,    26,    27,
      28,    29,    30,    31,    32,    33,   102,    84,   102,   315,
     316,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    84,    84,   102,   102,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    84,   102,   102,   102,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,   102,
      84,   102,   433,   434,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,   102,   102,   102,   102,    82,   102,
     102,   102,   102,   102,    81,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   433,   434,   102,
     102,   102,   102,   102,    84,    84,    84,    84,    98,    98,
      98,    98,   247,   240,   100,   100,    98,    98,   101,   253,
      84,    -1,   493,    98,    98,    98,    98,    98,    98,    98,
      98,   262,    91,   100,   100,    98,   101,    98,   278,   101,
      98,   101,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    98,    98,    98,    98,    98,   493,    98,    98,
      98,    98,    98,    98,    98,    98,    84,    84,    84,    82,
     284,   294
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   104,     0,     3,    11,    12,    81,   105,   110,    83,
      11,    80,   107,   108,    98,    11,     4,     5,     6,     7,
       8,     9,    10,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    73,    74,    75,    76,    77,    78,    79,    98,
      99,   105,   111,   114,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   131,   132,   136,   137,
     141,   144,   145,   148,   149,   152,   153,   156,    84,    87,
      88,   106,    83,    83,    83,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    11,   107,
     108,   112,   113,    83,    83,    83,    83,    83,    83,    83,
      87,    98,    98,    98,    98,    98,    84,    98,    98,    98,
      98,    98,    98,    98,    98,    83,    88,    98,   115,   115,
     115,   115,    82,   114,    22,    23,    24,    34,   128,   129,
     130,    34,    40,    63,    64,    65,    66,    67,    68,   133,
     134,   135,    35,    69,    70,    71,    72,   138,   139,   140,
      25,    26,    27,    28,    29,    30,    31,    32,    33,   142,
     143,    22,    23,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,   146,   147,    39,
      45,    48,    49,   150,   151,    45,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,   154,   155,   108,    84,    11,   107,   112,    84,   112,
     112,    84,   112,   112,   112,   112,   112,   112,   112,   115,
     115,    84,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    84,    84,    84,    11,   109,   109,    84,   109,
     112,   109,   109,   109,   109,    84,   109,   112,   109,   109,
     109,    84,   109,   112,   109,   109,   109,   109,   109,   109,
     109,    84,   112,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,    84,   112,   109,
     109,   109,   109,    84,   112,   109,   109,   109,   109,   109,
     109,   109,   109,    84,   112,    81,    87,    98,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    84,   115,   115,
     115,   115,   115,   115,   115,    95,    96,   115,   102,   102,
     102,   128,   102,   102,   102,   102,   102,   133,   102,   102,
     102,   102,   138,   102,   102,   102,   102,   102,   102,   102,
     142,   102,   102,   102,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   146,   102,   102,   102,   102,
     150,   102,   102,   102,   102,   102,   102,   102,   102,   154,
     108,   108,    84,    84,   112,    84,   112,    84,   112,    84,
     112,    84,    84,    84,    84,    84,   115,   115,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   111,    81,    98,    98,    98,    98,   100,
     100,    98,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    30,    31,    98,   100,   101,   100,   101,    98,    98,
     101,   101,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    98,    98,    98,    98,   108,   108,    84,    84,
      84,    84,    82,   111,   108,    82
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   103,   104,   104,   104,   104,   105,   106,   106,   107,
     107,   108,   108,   108,   109,   109,   110,   110,   110,   111,
     111,   112,   112,   113,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     116,   117,   117,   117,   117,   118,   119,   119,   119,   119,
     119,   120,   120,   121,   121,   122,   122,   123,   123,   124,
     124,   125,   125,   125,   125,   125,   125,   125,   126,   127,
     128,   128,   128,   129,   129,   130,   130,   130,   131,   132,
     133,   133,   133,   134,   134,   135,   135,   135,   135,   135,
     135,   135,   136,   137,   138,   138,   138,   139,   139,   140,
     140,   140,   140,   141,   142,   142,   142,   143,   143,   143,
     143,   143,   143,   143,   143,   143,   143,   143,   144,   145,
     146,   146,   146,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   148,
     149,   150,   150,   150,   151,   151,   151,   151,   152,   153,
     154,   154,   154,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   156
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     1,     1,     1,     1,
       2,     0,     1,     1,     0,     1,     5,    13,    11,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     2,     3,
       6,     4,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     6,     8,     6,     8,     3,     4,     6,     8,     6,
       8,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       0,     1,     3,     1,     1,     5,     5,     5,     4,     1,
       0,     1,     3,     1,     1,     5,     1,     1,     5,     5,
       5,     5,     4,     1,     0,     1,     3,     1,     1,     5,
       5,     5,     5,     4,     0,     1,     3,     5,     5,     5,
       1,     1,     5,     5,     5,     5,     5,     5,     1,     4,
       0,     1,     3,     5,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     1,     1,     5,     5,     1,
       4,     0,     1,     3,     5,     5,     5,     5,     1,     4,
       0,     1,     3,     5,     5,     5,     5,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     5,     5,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 381 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1959 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 382 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1965 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 383 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1971 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 384 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1977 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 388 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1983 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 392 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1989 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 393 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 1995 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 397 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2001 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 398 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2007 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 402 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2013 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 403 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2019 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 404 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2025 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 408 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2031 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 409 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2037 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 412 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = -1;

			proto_packet_finish();

			realloc_packet();
		}
#line 2049 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 419 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = (yyvsp[-10].number);
			max_cpu = (yyvsp[-8].number);

			if (min_cpu > max_cpu) {
				int tmp = min_cpu;

				min_cpu = max_cpu;
				max_cpu = tmp;
			}

			proto_packet_finish();

			realloc_packet();
		}
#line 2069 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 434 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = (yyvsp[-8].number);

			proto_packet_finish();

			realloc_packet();
		}
#line 2081 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 444 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2087 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 445 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2093 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 449 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2099 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 450 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2105 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 454 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2111 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 458 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[0].number)); }
#line 2117 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 459 "trafgen_parser.y" /* yacc.c:1646  */
    { set_multi_byte((uint8_t *) (yyvsp[0].str) + 1, strlen((yyvsp[0].str)) - 2); }
#line 2123 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 460 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2129 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 461 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2135 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 462 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2141 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 463 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2147 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 464 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2153 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 465 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2159 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 466 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2165 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 467 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2171 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 468 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2177 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 469 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_header_finish(hdr); }
#line 2183 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 470 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2189 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 475 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); }
#line 2195 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 477 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 2201 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 479 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) - (yyvsp[0].number); }
#line 2207 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 481 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * (yyvsp[0].number); }
#line 2213 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 483 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) / (yyvsp[0].number); }
#line 2219 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 485 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) % (yyvsp[0].number); }
#line 2225 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 487 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) & (yyvsp[0].number); }
#line 2231 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 489 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) | (yyvsp[0].number); }
#line 2237 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 491 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) ^ (yyvsp[0].number); }
#line 2243 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 493 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) << (yyvsp[0].number); }
#line 2249 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 495 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) >> (yyvsp[0].number); }
#line 2255 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 497 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = -1 * (yyvsp[0].number); }
#line 2261 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 499 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number);}
#line 2267 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 504 "trafgen_parser.y" /* yacc.c:1646  */
    { set_fill((yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2273 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 509 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[-1].number)); }
#line 2279 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 510 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint16_t __c = cpu_to_be16((uint16_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2289 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 515 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint32_t __c = cpu_to_be32((uint32_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2299 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 520 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint64_t __c = cpu_to_be64((uint64_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2309 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 529 "trafgen_parser.y" /* yacc.c:1646  */
    { set_rnd((yyvsp[-1].number)); }
#line 2315 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 534 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_IP); }
#line 2321 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 536 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP); }
#line 2327 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 538 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP); }
#line 2333 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 540 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP6); }
#line 2339 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 542 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP6); }
#line 2345 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 547 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2351 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 549 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2357 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 554 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2363 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 556 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2369 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 561 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_rnd(); }
#line 2375 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 563 "trafgen_parser.y" /* yacc.c:1646  */
    {
			int i, max = (yyvsp[-1].number);
			for (i = 0; i < max; ++i)
				set_dynamic_rnd();
		}
#line 2385 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 572 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_INC); }
#line 2391 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 574 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_INC); }
#line 2397 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 579 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_DEC); }
#line 2403 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 581 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_DEC); }
#line 2409 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 585 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2415 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 586 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2421 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 587 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2427 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 588 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2433 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 589 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2439 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 590 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2445 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 591 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2451 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 595 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2457 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 599 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ETH); }
#line 2463 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 603 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2469 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 604 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2475 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 605 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2481 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 609 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2487 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 610 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2493 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 615 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_bytes(hdr, ETH_DST_ADDR, (yyvsp[0].bytes)); }
#line 2499 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 617 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_bytes(hdr, ETH_SRC_ADDR, (yyvsp[0].bytes)); }
#line 2505 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 619 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ETH_TYPE, (yyvsp[0].number)); }
#line 2511 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 623 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2517 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 627 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_VLAN); }
#line 2523 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 631 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2529 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 632 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2535 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 633 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2541 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 637 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2547 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 643 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_TPID, (yyvsp[0].number)); }
#line 2553 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 645 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_TPID, ETH_P_8021Q); }
#line 2559 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 647 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_TPID, ETH_P_8021AD); }
#line 2565 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 649 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_TCI, (yyvsp[0].number)); }
#line 2571 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 651 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_PCP, (yyvsp[0].number)); }
#line 2577 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 653 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_DEI, (yyvsp[0].number)); }
#line 2583 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 655 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_VID, (yyvsp[0].number)); }
#line 2589 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 659 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2595 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 663 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_MPLS); }
#line 2601 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 667 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2607 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 668 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2613 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 669 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2619 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 673 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2625 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 674 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2631 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 679 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be32(hdr, MPLS_LABEL, (yyvsp[0].number)); }
#line 2637 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 681 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be32(hdr, MPLS_TC, (yyvsp[0].number)); }
#line 2643 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 683 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be32(hdr, MPLS_LAST, (yyvsp[0].number)); }
#line 2649 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 685 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be32(hdr, MPLS_TTL, (yyvsp[0].number)); }
#line 2655 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 689 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2661 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 693 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2667 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 694 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2673 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 695 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2679 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 700 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 2685 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 702 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 2691 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 704 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, (yyvsp[0].number)); }
#line 2697 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 706 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 2703 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 708 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 2709 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 710 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_HTYPE, (yyvsp[0].number)); }
#line 2715 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 712 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_PTYPE, (yyvsp[0].number)); }
#line 2721 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 714 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_bytes(hdr, ARP_SHA, (yyvsp[0].bytes)); }
#line 2727 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 716 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_bytes(hdr, ARP_THA, (yyvsp[0].bytes)); }
#line 2733 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 718 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u32(hdr, ARP_SPA, (yyvsp[0].ip4_addr).s_addr); }
#line 2739 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 720 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u32(hdr, ARP_TPA, (yyvsp[0].ip4_addr).s_addr); }
#line 2745 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 723 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ARP); }
#line 2751 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 727 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2757 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 731 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2763 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 732 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2769 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 733 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2775 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 738 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, IP4_VER, (yyvsp[0].number)); }
#line 2781 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 740 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, IP4_IHL, (yyvsp[0].number)); }
#line 2787 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 742 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u32(hdr, IP4_DADDR, (yyvsp[0].ip4_addr).s_addr); }
#line 2793 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 744 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u32(hdr, IP4_SADDR, (yyvsp[0].ip4_addr).s_addr); }
#line 2799 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 746 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, IP4_PROTO, (yyvsp[0].number)); }
#line 2805 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 748 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, IP4_TTL, (yyvsp[0].number)); }
#line 2811 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 750 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, IP4_DSCP, (yyvsp[0].number)); }
#line 2817 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 752 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, IP4_ECN, (yyvsp[0].number)); }
#line 2823 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 754 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, IP4_TOS, (yyvsp[0].number)); }
#line 2829 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 756 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_LEN, (yyvsp[0].number)); }
#line 2835 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 758 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_ID, (yyvsp[0].number)); }
#line 2841 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 760 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_FLAGS, (yyvsp[0].number)); }
#line 2847 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 761 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_DF, 1); }
#line 2853 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 762 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_MF, 1); }
#line 2859 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 764 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_FRAG_OFFS, (yyvsp[0].number)); }
#line 2865 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 766 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_CSUM, (yyvsp[0].number)); }
#line 2871 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 770 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_IP4); }
#line 2877 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 774 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2883 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 778 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2889 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 779 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2895 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 780 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2901 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 785 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, UDP_SPORT, (yyvsp[0].number)); }
#line 2907 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 787 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, UDP_DPORT, (yyvsp[0].number)); }
#line 2913 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 789 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, UDP_LEN, (yyvsp[0].number)); }
#line 2919 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 791 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, UDP_CSUM, (yyvsp[0].number)); }
#line 2925 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 795 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_UDP); }
#line 2931 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 799 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2937 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 803 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2943 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 804 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2949 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 805 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2955 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 810 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_SPORT, (yyvsp[0].number)); }
#line 2961 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 812 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_DPORT, (yyvsp[0].number)); }
#line 2967 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 814 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be32(hdr, TCP_SEQ, (yyvsp[0].number)); }
#line 2973 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 816 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be32(hdr, TCP_ACK_SEQ, (yyvsp[0].number)); }
#line 2979 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 818 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_DOFF, (yyvsp[0].number)); }
#line 2985 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 819 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_CWR, 1); }
#line 2991 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 820 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_ECE, 1); }
#line 2997 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 821 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_URG, 1); }
#line 3003 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 822 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_ACK, 1); }
#line 3009 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 823 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_PSH, 1); }
#line 3015 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 824 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_RST, 1); }
#line 3021 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 825 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_SYN, 1); }
#line 3027 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 826 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_FIN, 1); }
#line 3033 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 828 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_WINDOW, (yyvsp[0].number)); }
#line 3039 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 830 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_CSUM, (yyvsp[0].number)); }
#line 3045 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 832 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_URG_PTR, (yyvsp[0].number)); }
#line 3051 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 836 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_TCP); }
#line 3057 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;


#line 3061 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 839 "trafgen_parser.y" /* yacc.c:1906  */


static void finalize_packet(void)
{
	/* XXX hack ... we allocated one packet pointer too much */
	plen--;
	dlen--;
}

static void dump_conf(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		printf("[%zu] pkt\n", i);
		printf(" len %zu cnts %zu rnds %zu\n",
		       packets[i].len,
		       packet_dyn[i].clen,
		       packet_dyn[i].rlen);

		printf(" payload ");
		for (j = 0; j < packets[i].len; ++j)
			printf("%02x ", packets[i].payload[j]);
		printf("\n");

		for (j = 0; j < packet_dyn[i].clen; ++j)
			printf(" cnt%zu [%u,%u], inc %u, off %jd type %s\n", j,
			       packet_dyn[i].cnt[j].min,
			       packet_dyn[i].cnt[j].max,
			       packet_dyn[i].cnt[j].inc,
			       (intmax_t)packet_dyn[i].cnt[j].off,
			       packet_dyn[i].cnt[j].type == TYPE_INC ?
			       "inc" : "dec");

		for (j = 0; j < packet_dyn[i].rlen; ++j)
			printf(" rnd%zu off %jd\n", j,
			       (intmax_t)packet_dyn[i].rnd[j].off);
	}
}

void cleanup_packets(void)
{
	size_t i;

	for (i = 0; i < plen; ++i) {
		if (packets[i].len > 0)
			xfree(packets[i].payload);
	}

	free(packets);

	for (i = 0; i < dlen; ++i) {
		free(packet_dyn[i].cnt);
		free(packet_dyn[i].rnd);
	}

	free(packet_dyn);
}

void compile_packets(char *file, bool verbose, unsigned int cpu,
		     bool invoke_cpp, char *const cpp_argv[])
{
	char tmp_file[128];
	int ret = -1;

	memset(tmp_file, 0, sizeof(tmp_file));
	our_cpu = cpu;

	if (invoke_cpp) {
		if (cpp_exec(file, tmp_file, sizeof(tmp_file), cpp_argv)) {
			fprintf(stderr, "Failed to invoke C preprocessor!\n");
			goto err;
		}
		file = tmp_file;
	}

	if (!strncmp("-", file, strlen("-")))
		yyin = stdin;
	else
		yyin = fopen(file, "r");
	if (!yyin) {
		fprintf(stderr, "Cannot open %s: %s!\n", file, strerror(errno));
		goto err;
	}

	realloc_packet();
	if (yyparse() != 0)
		goto err;
	finalize_packet();

	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	if (yyin && yyin != stdin)
		fclose(yyin);

	if (invoke_cpp)
		unlink(tmp_file);
	if (ret)
		die();
}

void compile_packets_str(char *str, bool verbose, unsigned int cpu)
{
	int ret = 1;

	our_cpu = cpu;
	realloc_packet();

	yy_scan_string(str);
	if (yyparse() != 0)
		goto err;

	finalize_packet();
	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	yylex_destroy();

	if (ret)
		die();
}

void yyerror(const char *err)
{
	fprintf(stderr, "Syntax error at line %d, char '%s': %s\n", yylineno, yytext, err);
}
